Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 87022)
@@ -2579,7 +2579,6 @@
             &msgCenter(), &UIMessageCenter::sltResetSuppressedMessages, Qt::UniqueConnection);
 
-    /* 'Help' menu connections: */
-    connect(action(UIActionIndex_Simple_Contents), &UIAction::triggered,
-            &msgCenter(), &UIMessageCenter::sltShowHelpHelpDialog, Qt::UniqueConnection);
+    /* 'Help' menu connections. Note that connections for UIActionIndex_Simple_Contents is done
+     *   in manager and runtime uis separately in their respective classes: */
     connect(action(UIActionIndex_Simple_WebSite), &UIAction::triggered,
             &msgCenter(), &UIMessageCenter::sltShowHelpWebDialog, Qt::UniqueConnection);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 87022)
@@ -242,4 +242,31 @@
 }
 
+QString UIToolPaneGlobal::currentHelpKeyword() const
+{
+    QWidget *pCurrentToolWidget = 0;
+    //UIToolType currentTool() const;
+    switch (currentTool())
+    {
+        case UIToolType_Welcome:
+            pCurrentToolWidget = m_pPaneWelcome;
+            break;
+        case UIToolType_Media:
+            pCurrentToolWidget = m_pPaneMedia;
+            break;
+        case UIToolType_Network:
+            pCurrentToolWidget = m_pPaneNetwork;
+            break;
+        case UIToolType_Cloud:
+            pCurrentToolWidget = m_pPaneCloud;
+            break;
+        case UIToolType_Resources:
+            pCurrentToolWidget = m_pPaneResourceMonitor;
+            break;
+        default:
+            break;
+    }
+    return uiCommon().helpKeyword(pCurrentToolWidget);
+}
+
 void UIToolPaneGlobal::prepare()
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h	(revision 87022)
@@ -72,4 +72,6 @@
     /** Closes tool of passed @a enmType, deletes one if exists. */
     void closeTool(UIToolType enmType);
+    /** Returns the help keyword of the current tool's widget. */
+    QString currentHelpKeyword() const;
 
 private:
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp	(revision 87022)
@@ -311,4 +311,30 @@
 }
 
+QString UIToolPaneMachine::currentHelpKeyword() const
+{
+    QWidget *pCurrentToolWidget = 0;
+    switch (currentTool())
+    {
+        case UIToolType_Error:
+            pCurrentToolWidget = m_pPaneError;
+            break;
+        case UIToolType_Details:
+            pCurrentToolWidget = m_pPaneDetails;
+            break;
+        case UIToolType_Snapshots:
+            pCurrentToolWidget = m_pPaneSnapshots;
+            break;
+        case UIToolType_Logs:
+            pCurrentToolWidget = m_pPaneLogViewer;
+            break;
+        case UIToolType_Performance:
+            pCurrentToolWidget = m_pPanePerformanceMonitor;
+            break;
+        default:
+            break;
+    }
+    return uiCommon().helpKeyword(pCurrentToolWidget);
+}
+
 void UIToolPaneMachine::prepare()
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.h	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.h	(revision 87022)
@@ -98,4 +98,7 @@
     bool isCurrentStateItemSelected() const;
 
+    /** Returns the help keyword of the current tool's widget. */
+    QString currentHelpKeyword() const;
+
 private:
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 87022)
@@ -2139,4 +2139,9 @@
 }
 
+void UIVirtualBoxManager::sltPerformShowHelpBrowser()
+{
+    m_pWidget->showHelpBrowser();
+}
+
 void UIVirtualBoxManager::prepare()
 {
@@ -2476,4 +2481,10 @@
     connect(actionPool()->actionGroup(UIActionIndexMN_M_Machine_M_Tools), &QActionGroup::triggered,
             this, &UIVirtualBoxManager::sltPerformShowMachineTool);
+
+    /* 'Help' menu contents action connection. It is done here since we need different behaviour in
+     * the manager and runtime UIs: */
+    connect(actionPool()->action(UIActionIndex_Simple_Contents), &UIAction::triggered,
+        this, &UIVirtualBoxManager::sltPerformShowHelpBrowser);
+
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h	(revision 87022)
@@ -309,4 +309,7 @@
         /** Handles call to toggle machine search widget visibility to be @a fVisible. */
         void sltPerformMachineSearchWidgetVisibilityToggling(bool fVisible);
+
+        /** Handles call to show help viewer. */
+        void sltPerformShowHelpBrowser();
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 87022)
@@ -28,4 +28,5 @@
 #include "UIExtraDataManager.h"
 #include "UIChooser.h"
+#include "UIMessageCenter.h"
 #include "UIVirtualBoxManager.h"
 #include "UIVirtualBoxManagerWidget.h"
@@ -256,4 +257,15 @@
     if (pButton)
         pButton->setPopupMode(fSeparateMenuSection ? QToolButton::MenuButtonPopup : QToolButton::DelayedPopup);
+}
+
+void UIVirtualBoxManagerWidget::showHelpBrowser()
+{
+    QString strHelpKeyword;
+    if (isGlobalItemSelected())
+        strHelpKeyword = m_pPaneToolsGlobal->currentHelpKeyword();
+    else if (isMachineItemSelected())
+        strHelpKeyword = m_pPaneToolsMachine->currentHelpKeyword();
+
+    msgCenter().sltHandleHelpRequestWithKeyword(strHelpKeyword);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 87022)
@@ -209,4 +209,10 @@
     /** @} */
 
+    /** @name Help browser stuff.
+      * @{ */
+        /** Shpws the help browser. */
+        void showHelpBrowser();
+    /** @} */
+
 public slots:
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIWelcomePane.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIWelcomePane.cpp	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIWelcomePane.cpp	(revision 87022)
@@ -24,4 +24,5 @@
 /* GUI includes */
 #include "QIWithRetranslateUI.h"
+#include "UICommon.h"
 #include "UIIconPool.h"
 #include "UIWelcomePane.h"
@@ -214,4 +215,6 @@
     }
 
+    uiCommon().setHelpKeyword(this, "intro-starting");
+
     /* Translate finally: */
     retranslateUi();
Index: trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotPane.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotPane.cpp	(revision 87019)
+++ trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotPane.cpp	(revision 87022)
@@ -1205,4 +1205,7 @@
     loadSettings();
 
+
+    uiCommon().setHelpKeyword(this, "snapshots");
+
     /* Apply language settings: */
     retranslateUi();